import { NextHandleFunction } from 'connect';
import { Express } from 'express';
import { Logger } from 'winston';
import { ResultHandlerDefinition } from './result-handler';
export declare const loggerLevels: {
    silent: boolean;
    warn: boolean;
    debug: boolean;
};
export interface LoggerConfig {
    level: keyof typeof loggerLevels;
    color: boolean;
}
export declare type ConfigType = ({
    server: {
        listen: number | string;
        jsonParser?: NextHandleFunction;
    };
} | {
    app: Express;
}) & {
    cors: boolean;
    errorHandler?: ResultHandlerDefinition<any, any>;
    logger: LoggerConfig | Logger;
};
