"use strict";
var __classPrivateFieldGet = (this && this.__classPrivateFieldGet) || function (receiver, state, kind, f) {
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");
    return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
};
var _a, _EndpointsFactory_create;
Object.defineProperty(exports, "__esModule", { value: true });
exports.defaultEndpointsFactory = exports.EndpointsFactory = void 0;
const endpoint_1 = require("./endpoint");
const result_handler_1 = require("./result-handler");
/** mIN, mOUT - accumulated from all middlewares */
class EndpointsFactory {
    constructor(resultHandler) {
        this.resultHandler = resultHandler;
        this.middlewares = [];
        this.resultHandler = resultHandler;
    }
    addMiddleware(definition) {
        return __classPrivateFieldGet(EndpointsFactory, _a, "m", _EndpointsFactory_create).call(EndpointsFactory, this.middlewares.concat(definition), this.resultHandler);
    }
    build({ input, output, handler, description, ...rest }) {
        return new endpoint_1.Endpoint({
            handler, description,
            middlewares: this.middlewares,
            inputSchema: input,
            outputSchema: output,
            resultHandler: this.resultHandler,
            ...rest
        });
    }
}
exports.EndpointsFactory = EndpointsFactory;
_a = EndpointsFactory, _EndpointsFactory_create = function _EndpointsFactory_create(middlewares, resultHandler) {
    const factory = new EndpointsFactory(resultHandler);
    factory.middlewares = middlewares;
    return factory;
};
exports.defaultEndpointsFactory = new EndpointsFactory(result_handler_1.defaultResultHandler);
//# sourceMappingURL=endpoints-factory.js.map