import { ParseContext, ParseReturnType, ZodParsedType, ZodType, ZodString } from 'zod';
declare const zodFileKind = "ZodFile";
declare type ErrMessage = Exclude<Parameters<typeof ZodString.prototype.email>[0], undefined>;
declare type ZodFileCheck = {
    kind: 'binary';
    message?: string;
} | {
    kind: 'base64';
    message?: string;
};
export interface ZodFileDef {
    checks: ZodFileCheck[];
    typeName: typeof zodFileKind;
}
export declare class ZodFile extends ZodType<string, ZodFileDef> {
    _parse(ctx: ParseContext, data: any, parsedType: ZodParsedType): ParseReturnType<string>;
    binary: (message?: ErrMessage | undefined) => ZodFile;
    base64: (message?: ErrMessage | undefined) => ZodFile;
    get isBinary(): boolean;
    get isBase64(): boolean;
    static create: () => ZodFile;
}
export {};
